#require 'rubygems'
require 'sinatra/base'
require 'yaml'


class SinatraApp < Sinatra::Base


# SETUP
set :bind, '0.0.0.0'
set :port, 80
use Rack::Session::Pool
Encoding.default_external = "UTF-8"



# HELPERS ----------------------------------------------------------------------------------

def return_random(array, quantity)
	items = array
	results = []
	quantity.times do
		roll = items[rand(items.length)]
		#items.delete(roll)
		results << roll
	end
	return results
end

def return_random_exclusive(array, quantity)
	items = array
	results = []
	quantity.times do
		roll = items[rand(items.length)]
		items.delete(roll)
		results << roll unless roll.class == NilClass
	end
	return results
end

def return_random_consumibles(array, quantity)
	items = array
	results = []
	quantity.times do
		roll = items[rand(items.length)]
		#items.delete(roll)
		(rand(4)).times do
			results << roll
		end
	end
	return results
end

def heal(attribute, attr_max, quantity)
	attribute += quantity
	if attribute > attr_max then
		attribute = attr_max
	end
	return attribute
end

def if_equal(a,b,string)
	return string if a == b
end

def build_azotea
	azotea = {}
	azotea[:vecino_desnudo] = rand(2)
	azotea[:probabilidad_lluvia] = rand(100)
	azotea[:cotillas] = rand(30)
	return azotea
end

def build_parque
	parque = {}
	parque[:perros] = rand(99)+2
	parque[:camellos] = rand(101)
	parque[:cotillas] = rand(101)
	return parque
end

def absurd_sport
	n = ["body", "full", "kinetic", "acro", "kundalini", "magnetic", "static", "fisio", "spectrum", "active", "neuro", "senso"]
	m = ["aerobic", "crossfit", "combat", "zumba", "yoga"]
	nombre = n[rand(n.length)].capitalize + ' ' + m[rand(m.length)].capitalize
end

def poder_pagar(target, cuantia)
	dinero_restante = target[:dinero] - cuantia
	if dinero_restante < 0 then
		false
	else
		true
	end
end

def pick_another(me)
	choices = [:self]
	session[:companeros].each do |c|
		c_sigue_vivo = (!(session[:companeros][c[0]][:estados].include? 'muerto') && !(session[:companeros][c[0]][:estados].include? 'suicidio'))
		if c_sigue_vivo then
			unless c[0] == me then
				choices << c
			end
		end
	end
	return choices[rand(choices.length)]
end

def pick_another_to_plunder(me)
	choices = []
	session[:companeros].each do |c|
		c_sigue_vivo = (!(session[:companeros][c[0]][:estados].include? 'muerto') && !(session[:companeros][c[0]][:estados].include? 'suicidio'))
		c_no_saqueado = !(session[:companeros][c[0]][:estados].include? 'saqueado')
		c_tiene_algo = session[:companeros][c[0]][:objetos].any? || session[:companeros][c[0]][:consumibles].any?
		if !c_sigue_vivo && c_no_saqueado && c_tiene_algo then
			unless c[0] == me then
				choices << c
			end
		end
	end
	unless choices == []
		pick = choices[rand(choices.length)]
	else
		pick = nil
	end
	puts "Intenta saquear a #{pick}"
	return pick
end

def pick_another_to_recycle(me)
	choices = []
	session[:companeros].each do |c|
		c_sigue_vivo = (!(session[:companeros][c[0]][:estados].include? 'muerto') && !(session[:companeros][c[0]][:estados].include? 'suicidio'))
		puts "hablamos de #{c}"
		puts "sigue vivo? #{c_sigue_vivo}"
		c_reciclado = (session[:companeros][c[0]][:estados].include? 'reciclado')
		puts "reciclado? #{c_reciclado}"
		if !c_sigue_vivo && !c_reciclado then
			unless c[0] == me then
				choices << c
			end
		end
	end
	unless choices == []
		pick = choices[rand(choices.length)]
	else
		pick = nil
	end
	puts "Intenta reciclar a #{pick} (#{pick.inspect})"
	return pick
end

def pick_another_item(other)
	puts "el other es: #{other.inspect}"
	if other == 's' then #si le pasas other[0] y other == :self, recogerá 's'
		items = session[:atributos][:objetos]+session[:atributos][:consumibles]
	else
		items = session[:companeros][other][:objetos]+session[:companeros][other][:consumibles]
	end
	return items[rand(items.length)]
end

def pick_weapon(objetos)
	armas = ['sacacorchos', 'navaja', 'martillo', 'destornillador', 'picahielo', 'cuchillo', 'antimosquitos']
	seleccion = armas & objetos
	if seleccion.length > 0 then
		seleccion = seleccion[rand(seleccion.length)]
		return seleccion
	else
		return false
	end
end

def working_tools(target)
	puts "WORKING TOOLS"
	puts target
	puts session[:companeros][target].inspect
	puts session[:companeros][target][:objetos].include?('móvil')
	puts session[:companeros][target][:objetos].include?('ordenador')
	puts session[:companeros][target][:objetos].include?('móvil')||session[:companeros][target][:objetos].include?('ordenador')
	if session[:companeros][target][:objetos].include?('móvil')||session[:companeros][target][:objetos].include?('ordenador') then
		return true
	else
		return false
	end
end

def how_much_buy(target)
	raciones_disponibles = session[:companeros][target][:dinero]/session[:precio_comida]
	if raciones_disponibles > 0 then
		raciones = rand(raciones_disponibles) + 1
		return raciones
	else
		return false
	end
end


# JUEGO START ----------------------------------------------------------------------------------------------

get '/' do
	erb :hola, :layout => false
end

get '/gameover' do
	if (session[:atributos][:estados].include?('muerto') || session[:atributos][:estados].include?('suicidio')) then
		erb :muerte, :layout => false
	else
		redirect '/salon'
	end
end

get '/victoria' do
	if session[:turno] < session[:fin_cuarentena] then
		redirect '/salon'
	else
		erb :victoria, :layout => false
	end
end




get '/new' do

	# Items
	nombres = ['Javi', 'Antonio', 'Perico', 'Willy', 'Serezade', 'Mariano', 'Gloria', 'Juana', 'Sandro', 'Casimiro', 'Sarai', 'Pep', 'Rosa', 'Pablo', 'Beatriz', 'Joaquín', 'Santiago', 'Víctor', 'Ángel', 'Rubén', 'Eduardo', 'César', 'Marc', 'Tania', 'Albert', 'Priscila', 'Camilo','Oriol', 'Xavi', 'Carlos', 'Miguel', 'Ígor', 'Fran', 'Ana', 'Xue', 'Uxue', 'Zhao', 'María', 'Valvanuz', 'Helena', 'Iñaki', 'Yani', 'Mei', 'Pierre', 'Kevin', 'Flor', 'Carlos', 'Rahid', 'Ahmed', 'Liu', 'Andrés', 'Sabine', 'Claudia', 'Michael', 'Thomas', 'Philippe', 'Catherine', 'Giuseppe', 'Marco', 'Eduardo', 'Niels', 'Francesca', 'Valentina', 'Eva', 'Andrzej', 'Krzysztof', 'Anna', 'Agnieszka', 'Fátima', 'Lars','Daniel', 'Sergey', 'Alexander', 'Vladimir']
	apellidos = ['García', 'Pérez', 'Moreno', 'Muñoz', 'Vázquez', 'Vidal', 'Nieto', 'Aguilar', 'Hidalgo', 'Caballero', 'Soto', 'Moya', 'Gallardo', 'Crespo', 'Rojas', 'Morales', 'Delgado', 'Ramos', 'Castro', 'Ortega', 'Guerrero', 'Prieto', 'Tarradellas', 'Cano', 'Sanz', 'López', 'McCain', 'Toledo', 'Assan', 'Hache', 'Orozco', 'Rivas', 'Espínola', 'de Olivares', 'Carbonell','Torrijos', 'Ribera', 'Ordóñez', 'de los Monteros', 'Mukhtar', 'Aramburu', 'Aznar', 'Quevedo', 'Castelo', 'Broncano', 'Belaotxaga', 'Cixin', 'Carranza', 'Elejalde', 'Puig', 'Sardà', 'Muller', 'Fischer', 'Schmidt', 'Hoffmann', 'Verdejo', 'Antonescu', 'Hostaled', 'Ferreiroa', 'Ryah', 'Ilyes', 'Pacchioni', 'Ferrari', 'Russo', 'Romano', 'Fallo', 'Bianchi', 'Asoufi', 'Lakbiri', 'Angresola', 'Brose', 'Godet', 'Wyss', 'Guillade', 'Etxeandia', 'Benaldi', 'Bakkali', 'Kaddouri', 'Tahiri', 'Amrani']
	objetos = ['ordenador', 'satisfyer', 'navaja', 'balón', 'móvil', 'poemario', 'planta', 'botiquín', 'pesas', 'altavoz']
	objetos_cocina = ['cuchillo', 'sacacorchos', 'martillo', 'destornillador', 'picahielo']
	consumibles = ['marihuana', 'cocaína', 'condones', 'setas mágicas', 'barrita energética', 'chicle', 'cigarro', 'vodka', 'mascarilla', 'burundanga', 'antimosquitos']
	consumibles_mercado = ['condones', 'barrita energética', 'chicle', 'cigarro', 'vodka', 'comida', 'gel']
	session[:precios] = {
		'condones' => rand(10)+1,
		'barrita energética' => rand(10)+1,
		'chicle' => rand(10)+1,
		'cigarro' => rand(10)+1,
		'vodka' => rand(10)+1,
		'comida' => rand(10)+1,
		'gel' => rand(10)+1
	}

	# Setup básico
	session[:turno] = 1
	session[:fin_cuarentena] = 45+rand(56)
	session[:actions_this_round] = 1
	session[:eventos] = []
	session[:basura] = 0
	session[:precio_comida] = 1 + rand(5)
	session[:azotea] = build_azotea
	session[:parque] = build_parque
	fisico_start = (50 + rand(51))
	paciencia_start = (50 + rand(51))
	session[:atributos] = { 	:edad => 18 + rand(22),
							:fisico_max => fisico_start,
							:fisico_actual => fisico_start,
							:paciencia_max => paciencia_start,
							:paciencia_actual => paciencia_start,
							:dinero => (100 + rand(100)),
							:fuerza => 25 + rand(75),
							:destreza => 25 + rand(75),
							:inteligencia => 25 + rand(75),
							:estados => [],
							:objetos => return_random(objetos, rand(10)/2),
							:consumibles => return_random_consumibles(consumibles, rand(3)+2)
							#:consumibles => ['marihuana', 'cocaína', 'condón', 'setas mágicas', 'barrita energética', 'chicle', 'cigarro', 'vodka', 'mascarilla', 'burundanga', 'antimosquitos']
							}
	session[:atributos][:objetos] << 'móvil'

	# Diseñar compañeros
	session[:companeros] = {}
	n_companeros = rand(4) + 2
	n_companeros.times do |t|
		fisico_start = (50 + rand(51))
		paciencia_start = (50 + rand(51))
		session[:companeros].merge!(t+1 => {
			:nombre => return_random(nombres, 1)[0].to_s + ' ' + return_random(apellidos, 1)[0].to_s,
			:edad => 18 + rand(22),
 			:fisico_max =>fisico_start,
			:fisico_actual => fisico_start,
			:paciencia_max => paciencia_start,
			:paciencia_actual => paciencia_start,
			:dinero => (100 + rand(100)),
			:fuerza => 15 + rand(85),
			:destreza => 15 + rand(85),
			:inteligencia => 15 + rand(85),
			:estados => [],
			:objetos => return_random(objetos, rand(10)/2),
			:consumibles => return_random_consumibles(consumibles, rand(9)+2)
		})
		#puts session[:companeros][t+1].inspect
	end

	# Diseñar gatos
	session[:gatos] = rand(4)

	#Diseñar perro
	perro = rand(2)
	if perro == 1 then
		nombres_perro = ['Max', 'Casper', 'Napoleón', 'Gervasio', 'Pipu', 'Toby', 'Johan Sebastian', 'Conan']
		session[:perro] = {:nombre => return_random(nombres_perro, 1)[0],
						:tamano => 1+rand(4),
						:edad => 1+rand(19),
						:caca_y_pis => rand(30)}
	else
		session[:perro] = nil
	end

	# Diseñar piso
	session[:cocina] = {:comida => rand(300),
					:objetos => return_random_exclusive(objetos_cocina, rand(consumibles.length))}

	session[:wc] = {:ocupado => false,
					:gel => rand(100)}

	session[:mercado] = {:consumibles => return_random_consumibles(consumibles_mercado, rand(consumibles_mercado.length))*5 }

	# Diseñar intro
	ciudades = ["Barcelona", "Madrid", "Bilbao", "Sevilla", "Valencia", "A Coruña", "León", "Castellón", "Alicante", "Pontevedra", "Vitoria", "Donistia", "Gerona", "Cádiz", "Albacete", "Almería", "Granada", "Pamplona", "Zamora", "Valladolid", "Almería", "Burgos", "Cádiz", "Cuenca", "Guadalajara", "Salamanca", "Gijón", "Santander", "Murcia", "Teruel", "Logroño"]
	session[:intro] = "🛑 El Gobierno ha decretado la cuarentena obligatoria. Tu jefe ha aprovechado para despedirte. Tus padres se han desentendido de ti. Tú y tus compañeros deberéis sobrevivir #{session[:fin_cuarentena]} turnos sin morir de hambre o desesperación. Vives con #{session[:companeros].count} personas en un cuchitril a las afueras de #{ciudades[rand(ciudades.length)]}."
	
	if perro == 1 then
		case session[:perro][:tamano]
		when 1
			t_p = "enano"
		when 2
			t_p = "mediano"
		when 3
			t_p = "grande"
		when 4 
			t_p = "enorme"
		end
		session[:intro] += " Por suerte tienes a tu mejor amigo #{session[:perro][:nombre]}, un perro #{t_p} de #{session[:perro][:edad]} años."
	end

	if session[:gatos] > 0 then
		session[:intro] += " En la casa también hay #{session[:gatos]} gatos sin nombre ni dueño."
	end

	session[:eventos] << session[:intro]

	redirect '/salon'
end


# ADS helper by for https://publishers.infolinks.com/

get '/ads.txt' do
  send_file 'public/ads.txt'
end


# Lugares ---------------------------------------------------------------------------------------------------

get '/azotea' do
	erb :azotea
end

get '/salon' do
	#erb :victoria, :layout => false
	erb :salon
end

get '/cocina' do
	erb :cocina
end

get '/hab' do
	erb :habitacion, :locals => { :c => session[:atributos] }
end

get '/hab/:id' do
	erb :habitacion, :locals => { :c => session[:companeros][params['id'].to_i] }
end

get '/parque' do
	erb :parque
end

get '/supermercado' do
	erb :supermercado
end


# Acciones post --------------------------

post '/coger_cocina' do
	cogido = params[:bien]
	turno = session[:turno].to_s
	turno_s = "[#{turno}] "
	session[:eventos] << "😎" + turno_s + coger(:self, session[:cocina][:objetos], cogido)
	redirect '/do/nil'
end

post '/steal' do
	cogido = params[:bien]
	cogido_a = params[:compa].to_i
	turno = session[:turno].to_s
	turno_s = "[#{turno}] "
	session[:eventos] << "😎" + turno_s + steal(:self, cogido_a, cogido)
	redirect '/do/nil'
end

post '/consume' do
	consumido = params[:bien]
	turno = session[:turno].to_s
	turno_s = "[#{turno}] "
	session[:eventos] << "😎" + turno_s + consume(:self, :self, consumido)
	redirect '/do/nil'
end

post '/buyfood' do
	puts "COMPRANDO COMIDA..."
	puts params[:raciones]
	comprado = params[:raciones]
	turno = session[:turno].to_s
	turno_s = "[#{turno}] "
	session[:eventos] << "😎" + turno_s + buy_food(:self, comprado)
	redirect '/do/nil'
end



# Action loop  (main game mechanic) ----------------------------------------------------------------------------------------------

get '/do/:action' do
	action = params['action']
	session[:actions_this_round] = 1
	turno = session[:turno].to_s
	turno_s = "[#{turno}] "
	#Besides: .../?target=T params['target']

	# Whipe states
		#dormido


	# Self actions
	puts "=============================> TURNO: JUGADOR"
	case action
	when 'nothing'
		session[:eventos] << "😎" + turno_s + nothing(:self)
	when 'hit-head'
		session[:eventos] << "😎" + turno_s + hit_head(:self)
	when 'sleep-in-couch'
		session[:eventos] << "😎" + turno_s + sleep_in_couch(:self)
	when 'cat-pet'
		session[:eventos] << "😎" + turno_s + cat_pet(:self)
	when 'cat-sacrifice'
		session[:eventos] << "😎" + turno_s + cat_sacrifice(:self)
	when 'fitness-azotea'
		session[:eventos] << "😎" + turno_s + fitness_azotea(:self)
	when 'tomar-aire'
		session[:eventos] << "😎" + turno_s + tomar_aire(:self)
	when 'espiar-desnudo'
		session[:eventos] << "😎" + turno_s + espiar_desnudo(:self)
	when 'cocinar'
		session[:eventos] << "😎" + turno_s + cocinar(:self)
	#when '/coger'
		#go to post '/coger'
	when 'wank'
		session[:eventos] << "😎" + turno_s + wank(:self)
	when 'flirt'
		session[:eventos] << "😎" + turno_s + flirt(:self, params['susodiche'])
	when 'molest'
		session[:eventos] << "😎" + turno_s + molest(:self, params['susodiche'])
	when 'attack'
		session[:eventos] << "😎" + turno_s + attack(:self, params['susodiche'])
	when 'steal'
		#session[:eventos] << "😎" + turno_s + steal(:self, params['susodiche']) #esto pasa en la ruta POST, nunca aquí
	when 'plunder'
		session[:eventos] << "😎" + turno_s + plunder(:self, params['susodiche'])
	when 'recycle'
		session[:eventos] << "😎" + turno_s + recycle(:self, params['susodiche'])		
	when 'walkdog'
		session[:eventos] << "😎" + turno_s + walkdog
	when 'buydrogaina'
		session[:eventos] << "😎" + turno_s + buy_drogaina(:self)
	when 'teletrabajo'
		puts "TELETRABAJANDOOOOOOOOOOOO"
		session[:eventos] << "😎" + turno_s + teletrabajar(:self)
	when 'nil'
		'nil'
		puts "Nadeando"
	end


	# Status checker pre (death?)
	puts "=============================> CHEKER (PRE)"
	if session[:atributos][:fisico_actual] <= 0 then
		session[:atributos][:estados] << 'muerto'
		session[:eventos] << "💀 Has muerto."; session[:actions_this_round] += 1
		redirect '/gameover'
	end

	if session[:atributos][:paciencia_actual] <= 0 then
		session[:atributos][:estados] << 'suicidio'
		session[:eventos] << "☠ Se te ha acabado la paciencia y te has suicidado."; session[:actions_this_round] += 1
		redirect '/gameover'
	end

	session[:companeros].each do |c|
		unless session[:companeros][c[0]][:estados].include? 'deceso notificado' then
			i = c[0]
			if session[:companeros][i][:fisico_actual] <= 0 then
				session[:companeros][i][:estados] << 'muerto'
				session[:eventos] << "💀 #{session[:companeros][i][:nombre]} ha muerto."; session[:actions_this_round] += 1
				session[:companeros][i][:estados] << 'deceso notificado'
			end
		end
	end

	session[:companeros].each do |c|
		unless session[:companeros][c[0]][:estados].include? 'deceso notificado' then
			i = c[0]
			if session[:companeros][i][:paciencia_actual] <= 0 then
				session[:companeros][i][:estados] << 'suicidio'
				session[:eventos] << "☠ #{session[:companeros][i][:nombre]} ha perdido la paciencia y se ha suicidado."; session[:actions_this_round] += 1
				session[:companeros][i][:estados] << 'deceso notificado'
			end
		end
	end

	# Process mates (AI)

	session[:companeros].each do |c|
		begin
		c_sigue_vivo = (!(session[:companeros][c[0]][:estados].include? 'muerto') && !(session[:companeros][c[0]][:estados].include? 'suicidio'))
		puts "c_sigue_vivo: #{c_sigue_vivo}"
		if c_sigue_vivo
			puts "=============================> TURNO: #{c[0]}"
			roll = rand(100)
			#roll = 'testing'
			case roll
			when 0..2
				puts "1"; session[:eventos] << "🤖 " + nothing(c[0])
			when 3..4
				puts "2"; session[:eventos] << "🤖 " + hit_head(c[0])
			when 5..12
				puts "2.2"; session[:eventos] << "🤖 " + teletrabajar(c[0])
			when 13..19
				puts "3"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
			when 20..26
				if session[:gatos] > 0 then
					puts "4"; session[:eventos] << "🤖 " + cat_pet(c[0])
				else
					puts "5"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
				end
			when 27..28
				if session[:gatos] > 0 then
					puts "6"; session[:eventos] << "🤖 " + cat_sacrifice(c[0])
				else
					puts "7"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
				end
			when 29..34
				case rand(3)
				when 0
					puts "8"; session[:eventos] << "🤖 " + fitness_azotea(c[0])
				when 1
					puts "9"; session[:eventos] << "🤖 " + tomar_aire(c[0])
				when 2
					puts "10"; session[:eventos] << "🤖 " + espiar_desnudo(c[0])
				end
			when 35..40
				if session[:cocina][:comida] > 0 then
					puts "11"; session[:eventos] << "🤖 " + cocinar(c[0])
				else
					cantidad = how_much_buy(c[0])
					if cantidad != false then
						puts "23"; session[:eventos] << "🤖 " + buy_food(c[0], cantidad)
					else
						puts "19.2"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
					end
				end
			when 41..43
				if session[:cocina][:objetos].count > 0 then
					puts "13"; session[:eventos] << "🤖 " + coger(c[0], session[:cocina][:objetos], session[:cocina][:objetos][rand(session[:cocina][:objetos].length)])
				else
					cantidad = how_much_buy(c[0])
					if cantidad != false then
						puts "23"; session[:eventos] << "🤖 " + buy_food(c[0], cantidad)
					else
						puts "19.2"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
					end
				end
			when 44..54
				puts "15"; session[:eventos] << "🤖 " + wank(c[0])
			when 55..61
				puts "16"; session[:eventos] << "🤖 " + flirt(c[0], pick_another(c[0]))
			when 62..67
					session[:eventos] << "🤖 " + buy_drogaina(c[0])
			when 68..69
				puts "17"; session[:eventos] << "🤖 " + molest(c[0], pick_another(c[0]))
			when 70..74
				puts "18"; session[:eventos] << "🤖 " + attack(c[0], pick_another(c[0]))
				#session[:eventos] << turno_s + nothing(c[0])
			when 75..79
				other = pick_another(c[0])
				item = pick_another_item(other[0])
				unless item == nil then
					puts "19.1"; session[:eventos] << "🤖 " + steal(c[0], other, item)
				else
					puts "19.2"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
				end
			when 80..89
				if c[1][:consumibles].any? then
					puts "20.1"; session[:eventos] << "🤖 " + consume(c[0], c[0], c[1][:consumibles][rand(c[1][:consumibles].length)])
				else
					cantidad = how_much_buy(c[0])
					if cantidad != false then
						puts "23"; session[:eventos] << "🤖 " + buy_food(c[0], cantidad)
					else
						puts "19.2"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
					end
				end
			when 90..94
				other = pick_another_to_plunder(c[0])
				unless other == nil then
					puts "21.1"; session[:eventos] << "🤖 " + plunder(c[0], other)
				else
					puts "21.2"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
				end
			when 95..99
				other = pick_another_to_recycle(c[0])
				unless other == nil then
					puts "22.1"; session[:eventos] << "🤖 " + recycle(c[0], other)
				else
					cantidad = how_much_buy(c[0])
					if cantidad != false then
						puts "23"; session[:eventos] << "🤖 " + buy_food(c[0], cantidad)
					else
						puts "19.2"; session[:eventos] << "🤖 " + sleep_in_couch(c[0])
					end
				end
			when 'testing'
				#cantidad = how_much_buy(c[0])
				#if cantidad != false then
				#	puts "23"; session[:eventos] << "🤖 " + buy_food(c[0], cantidad)
				#else
				#	puts "22.2"; session[:eventos] << "🤖 " + nothing(c[0])
				#end
			end
			session[:actions_this_round] += 1

				# Status checker post (en caso de que otro factor distinto al jugador le haya afectado)
				puts "=============================> CHEKER (POST)"


				session[:companeros].each do |c|
					unless session[:companeros][c[0]][:estados].include? 'deceso notificado' then
						i = c[0]
						if session[:companeros][i][:fisico_actual] <= 0 then
							session[:companeros][i][:estados] << 'muerto'
							session[:eventos] << "💀 #{session[:companeros][i][:nombre]} ha muerto."; session[:actions_this_round] += 1
							session[:companeros][i][:estados] << 'deceso notificado'
						end
					end
				end

				session[:companeros].each do |c|
					unless session[:companeros][c[0]][:estados].include? 'deceso notificado' then
						i = c[0]
						if session[:companeros][i][:paciencia_actual] <= 0 then
							session[:companeros][i][:estados] << 'suicidio'
							session[:eventos] << "☠ #{session[:companeros][i][:nombre]} ha perdido la paciencia y se ha suicidado."; session[:actions_this_round] += 1
							session[:companeros][i][:estados] << 'deceso notificado'
						end
					end
				end

				if session[:atributos][:fisico_actual] <= 0 then
					session[:atributos][:estados] << 'muerto'
					session[:eventos] << "💀 Has muerto."; session[:actions_this_round] += 1
					redirect '/gameover'
				end

				if session[:atributos][:paciencia_actual] <= 0 then
					session[:atributos][:estados] << 'suicidio'
					session[:eventos] << "☠ Se te ha acabado la paciencia y te has suicidado."; session[:actions_this_round] += 1
					redirect '/gameover'
				end
		else
			# Este compañero está muerto
		end
		rescue # En caso de que la AI pete
			excusas = ["Por favor, circulen", "Ignora esto y sigue genándote", "El Agente Smith está de camino", "La culpa de todo la tiene Yoko Ono", "No te fíes si ves un gato", "Esquiva esto", "Fdo.: Cifra", "Sigue al conejo blanco"]
			session[:eventos] << "🐈 #{session[:companeros][c[0]][:nombre]} ha intentado hacer algo, pero un fallo en Matrix se lo ha impedido (ERROR: #{roll}). Puedes seguir jugando, pero El Arquitecto está muy cabreado. #{excusas[rand(excusas.length)]}."; session[:actions_this_round] += 1
		end
	end

	# Extras
	puts "=============================> TURNO: EXTRAS"
	begin
		hay_noticia = rand(100)+1
		if hay_noticia <= 50 then
			session[:eventos] << "📺 " + inventa_noticia; session[:actions_this_round] += 1
		end
	rescue
		excusas = ["Por favor, circulen", "Ignora esto y sigue genándote", "El Agente Smith está de camino", "La culpa de todo la tiene Yoko Ono", "No te fíes si ves un gato", "Esquiva esto", "Fdo.: Cifra", "Sigue al conejo blanco"]
		session[:eventos] << "📺 La tele ha perdido la señal durante un rato. Puedes seguir jugando, pero El Arquitecto está muy cabreado. #{excusas[rand(excusas.length)]}."; session[:actions_this_round] += 1
	end


	# Si ha pasado la cuarentena
	if session[:turno] >= session[:fin_cuarentena] then
		redirect '/victoria'
	end

	# Add 1, build next, to the round and reload
	puts "=============================> TURNO: PREPARAR NUEVO TURNO"
	session[:azotea] = build_azotea
	session[:parque] = build_parque
	session[:precio_comida] = 1 + rand(5)
	session[:turno] += 1
	redirect '/salon'
end


# Acciones -------------------------------------------------------------------------------

def nothing(target)
	deterioro = rand(5)
	if target == :self then
		resultado = "No haces nada."
		if deterioro > 0 then
			session[:atributos][:paciencia_actual] -= deterioro
			resultado += " Pierdes #{deterioro} puntos de paciencia."
		end
	else
		resultado = "#{session[:companeros][target][:nombre]} no hace nada."
		if deterioro > 0 then
			session[:companeros][target][:paciencia_actual] -= deterioro
			resultado += " Pierde #{deterioro} puntos de paciencia."
		end
	end

	hambre = rand(3)
	if target == :self then
		if hambre > 0 then
			session[:atributos][:fisico_actual] -= hambre
			resultado += " Tienes hambre y pierdes #{hambre} puntos de salud."
		end
	else
		resultado = "#{session[:companeros][target][:nombre]} no hace nada."
		if hambre > 0 then
			session[:companeros][target][:fisico_actual] -= hambre
			resultado += " Tiene hambre y pierde #{hambre} puntos de salud."
		end		
	end
	return resultado 
end

def hit_head(target)
	deterioro = rand(5)
	if target == :self then
		resultado = "Te golpeas la cabeza contra la pared."
		if deterioro > 0 then
			session[:atributos][:fisico_actual] -= deterioro
			resultado += " Pierdes #{deterioro} puntos de salud."
		end
		return resultado
	else
		resultado = "#{session[:companeros][target][:nombre]} no hace nada."
		if deterioro > 0 then
			session[:companeros][target][:fisico_actual] -= deterioro
			resultado += " Pierde #{deterioro} puntos de salud."
		end
		return resultado 
	end
end

def sleep_in_couch(target)
	salud = rand(11)
	paciencia = rand(11)
	if target == :self then
		resultado = "Echas una cabezadita viendo la tele."
		#session[:atributos][:estados] << 'durmiendo-sofá'
		if salud > 0 then
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
			resultado += " Tienes hambre y pierdes #{salud} puntos de salud."
		end
		if paciencia > 0 then
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],salud)
			resultado += " Ganas #{paciencia} puntos de paciencia."
		end
		return resultado 
	else
		resultado = "#{session[:companeros][target][:nombre]} se duerme viendo la tele."
		#session[:companeros][target][:estados] << 'durmiendo-sofá'
		if salud > 0 then
			session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
			resultado += " Tiene hambre y pierde #{salud} puntos de salud."
		end
		if paciencia > 0 then
			session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			resultado += " Gana #{paciencia} puntos de paciencia."
		end	
		return resultado 	
	end
end

def cat_pet(target)
	resultado = ''
	cat_roll = rand(50) - 25
	if target == :self then
		usr_roll = session[:atributos][:destreza]
		if usr_roll > cat_roll then
			paciencia_extra = rand(8)
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia_extra)
			resultado = "Acaricias al gato. ¡Miu! El gato se deja acariciar. Ganas #{paciencia_extra} puntos de paciencia."
		else
			harm = -1 * (rand(4) + 1)
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],harm)
			resultado = "Acaricias al gato. ¡Ffffssshhhh! El gato te araña. Pierdes #{harm.abs} puntos de salud."
		end
	else
		usr_roll = session[:companeros][target][:destreza]
		if usr_roll > cat_roll then
			paciencia_extra = rand(8)
			session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia_extra)
			resultado = "#{session[:companeros][target][:nombre]} acaricia a un gato. ¡Miu! El gato se deja acariciar. Gana #{paciencia_extra} puntos de paciencia."
		else
			harm = -1 * (rand(4) + 1)
			session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],harm)
			resultado = "#{session[:companeros][target][:nombre]} acaricia a un gato. ¡Ffffssshhhh! El gato le araña. Pierde #{harm.abs} puntos de salud."
		end
	end
	return resultado
end

def cat_sacrifice(target)
	resultado = ''
	cat_roll = rand(50) + 25
	if target == :self then
		usr_roll = session[:atributos][:destreza]
		if usr_roll > cat_roll then
			raciones_extra = rand(4) + 1
			session[:gatos] -= 1
			#raciones_extra.times do
			#	session[:atributos][:consumibles] << 'comida'
			#end
			session[:cocina][:comida] += raciones_extra
			resultado = "Sacrificas un gato. ¡Meeoowwwrrr! Consigues #{raciones_extra} raciones de comida. Quedan #{session[:gatos]} vivos..."
		else
			harm = -1 * (rand(15) + 1)
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],harm)
			resultado = "Intentas sacrificar al gato pero consigue huir. ¡Ffffssshhhh! Pierdes #{harm} puntos de salud."
		end
	else
		usr_roll = session[:companeros][target][:destreza]
		if usr_roll > cat_roll then
			raciones_extra = rand(4) + 1
			session[:gatos] -= 1
			#raciones_extra.times do
			#	session[:companeros][target][:consumibles] << 'comida'
			#end
			session[:cocina][:comida] += raciones_extra
			resultado = "#{session[:companeros][target][:nombre]} sacrifica un gato. ¡Meeoowwwrrr! Consigue #{raciones_extra} raciones de comida. Quedan #{session[:gatos]} vivos..."
		else
			harm = -1 * (rand(15) + 1)
			session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],harm)
			resultado = "#{session[:companeros][target][:nombre]} intenta sacrificar un gato, pero el animal huye. ¡Ffffssshhhh! Pierde #{harm.abs} puntos de salud."
		end
	end
	return resultado
end

def fitness_azotea(target)
	salud = rand(10)
	paciencia = rand(5)
	if target == :self then
		evitar_cotillas = rand(session[:atributos][:inteligencia])
		resultado = "Subes a la azotea a hacer deporte."
		if salud > 0 then
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],salud)
			resultado += " Ganas #{salud} puntos de salud."
		end
		if paciencia > 0 then
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],salud)
			resultado += " Ganas #{paciencia} puntos de paciencia."
		end
		if evitar_cotillas > session[:azotea][:cotillas] then
			resultado += " Ningún cotilla se da cuenta de que estás ahí. Nadie llama a la policía."
		else
			multa = rand(51)
			if poder_pagar(session[:atributos],multa) then
				resultado += " Las zonas comunes no son privadas. Alguien te denuncia. Te multan con #{multa}€."
				session[:atributos][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Las zonas comunes no son privadas. Alguien te denuncia. Te multan con #{multa}€. Como no puedes pagar, te quedas sin dinero y recibes una paliza que te resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:atributos][:fisico_actual] -= golpe
				session[:atributos][:dinero] = 0
			end
		end
		return resultado 
	else
		evitar_cotillas = rand(session[:companeros][target][:inteligencia])
		resultado = "#{session[:companeros][target][:nombre]} sube a la azotea a hacer deporte."
		if salud > 0 then
			session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],salud)
			resultado += " Gana #{salud} puntos de salud."
		end
		if paciencia > 0 then
			session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			resultado += " Gana #{paciencia} puntos de paciencia."
		end
		if evitar_cotillas > session[:azotea][:cotillas] then
			resultado += " Ningún cotilla se da cuenta de que ha estado ahí. Nadie llama a la policía."
		else
			multa = rand(51)
			if poder_pagar(session[:companeros][target],multa) then
				resultado += " Las zonas comunes no son privadas. Alguien le denuncia. Le multan con #{multa}€."
				session[:companeros][target][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Las zonas comunes no son privadas. Alguien le denuncia. Le multan con #{multa}€. Como no puede pagar, se queda sin dinero y recibe una paliza que le resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:companeros][target][:fisico_actual] -= golpe
				session[:companeros][target][:dinero] = 0
			end
		end	
		return resultado 	
	end
end

def tomar_aire(target)
	salud = rand(4)
	paciencia = rand(4)
	lluvia = rand(session[:azotea][:probabilidad_lluvia])
	if target == :self then
		evitar_cotillas = rand(session[:atributos][:inteligencia])
		resultado = "Subes a la azotea a tomar el aire."
		if salud > 0 then
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],salud)
			resultado += " Ganas #{salud} puntos de salud."
		end
		if paciencia > 0 then
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],salud)
			resultado += " Ganas #{paciencia} puntos de paciencia."
		end
		if lluvia <= session[:azotea][:probabilidad_lluvia] then
			cold = rand(5)
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*cold)
			resultado += " Empieza a llover y te chopas. Pierdes #{cold} puntos de salud."
		end
		if evitar_cotillas > session[:azotea][:cotillas] then
			resultado += " Ningún cotilla se da cuenta de que estás ahí. Nadie llama a la policía."
		else
			multa = rand(51)
			if poder_pagar(session[:atributos],multa) then
				resultado += " Las zonas comunes no son privadas. Alguien te denuncia. Te multan con #{multa}€."
				session[:atributos][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Las zonas comunes no son privadas. Alguien te denuncia. Te multan con #{multa}€. Como no puedes pagar, te quedas sin dinero y recibes una paliza que te resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:atributos][:fisico_actual] -= golpe
				session[:atributos][:dinero] = 0
			end
		end
		return resultado 
	else
		evitar_cotillas = rand(session[:companeros][target][:inteligencia])
		resultado = "#{session[:companeros][target][:nombre]} sube a la azotea a tomar el aire."
		if salud > 0 then
			session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],salud)
			resultado += " Gana #{salud} puntos de salud."
		end
		if paciencia > 0 then
			session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			resultado += " Gana #{paciencia} puntos de paciencia."
		end
		if lluvia <= session[:azotea][:probabilidad_lluvia] then
			cold = rand(5)
			session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*cold)
			resultado += " Empieza a llover y se chopa. Pierde #{cold} puntos de salud."
		end
		if evitar_cotillas > session[:azotea][:cotillas] then
			resultado += " Ningún cotilla se da cuenta de que ha estado ahí. Nadie llama a la policía."
		else
			multa = rand(51)
			if poder_pagar(session[:companeros][target],multa) then
				resultado += " Las zonas comunes no son privadas. Alguien le denuncia. Le multan con #{multa}€."
				session[:companeros][target][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Las zonas comunes no son privadas. Alguien le denuncia. Le multan con #{multa}€. Como no puede pagar, se queda sin dinero y recibe una paliza que le resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:companeros][target][:fisico_actual] -= golpe
				session[:companeros][target][:dinero] = 0
			end
		end	
		return resultado 	
	end
end

def espiar_desnudo(target)
	salud = rand(4) + 1
	paciencia = rand(6) + 1
	persona_desnuda_dex = rand(75)
	if target == :self then
		evitar_cotillas = rand(session[:atributos][:inteligencia])
		evitar_ser_visto = rand(session[:atributos][:destreza])
		resultado = "Encuentras un rincón desde el que espiar a la persona desnuda, desabrochas tus pantalones y..."
		if persona_desnuda_dex > evitar_ser_visto then
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*salud)
			resultado += " ¡Te pillan! El bofetón te causa #{salud} puntos de daño."
		end
		session[:atributos][:paciencia_actual] += paciencia
		resultado += " Ganas #{paciencia} puntos de paciencia."
		if evitar_cotillas > session[:azotea][:cotillas] then
			resultado += " Ningún cotilla se da cuenta de que estás ahí. Nadie llama a la policía."
		else
			multa = rand(51)
			if poder_pagar(session[:atributos],multa) then
				resultado += " Las zonas comunes no son privadas. Alguien te denuncia. Te multan con #{multa}€."
				session[:atributos][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Las zonas comunes no son privadas. Alguien te denuncia. Te multan con #{multa}€. Como no puedes pagar, te quedas sin dinero y recibes una paliza que te resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:atributos][:fisico_actual] -= golpe
				session[:atributos][:dinero] = 0
			end
		end
		return resultado 
	else
		evitar_cotillas = rand(session[:companeros][target][:inteligencia])
		evitar_ser_visto = rand(session[:companeros][target][:destreza])
		resultado = "#{session[:companeros][target][:nombre]} intenta masturbarse espiando a una persona desnuda en la azotea."
		if persona_desnuda_dex > evitar_ser_visto then
			session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:atributos][:paciencia_max],-1*salud)
			resultado += " ¡Le pillan! El bofetón le causa #{salud} puntos de daño."
		end
		session[:companeros][target][:paciencia_actual] += paciencia
		resultado += " Gana #{paciencia} puntos de paciencia."
		if evitar_cotillas > session[:azotea][:cotillas] then
			resultado += " Ningún cotilla se da cuenta de que ha estado ahí. Nadie llama a la policía."
		else
			multa = rand(51)
			if poder_pagar(session[:companeros][target],multa) then
				resultado += " Las zonas comunes no son privadas. Alguien le denuncia. Le multan con #{multa}€."
				session[:companeros][target][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Las zonas comunes no son privadas. Alguien le denuncia. Le multan con #{multa}€. Como no puede pagar, se queda sin dinero y recibe una paliza que le resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:companeros][target][:fisico_actual] -= golpe
				session[:companeros][target][:dinero] = 0
			end
		end	
		return resultado 	
	end
end

def cocinar(target)
	if target == :self then
		discernimiento = session[:atributos][:inteligencia]
	else
		discernimiento = session[:companeros][target][:inteligencia]
	end

	raciones_disponibles = session[:cocina][:comida]
	if discernimiento >= rand(100) then
		raciones_usadas = (raciones_disponibles - (rand(raciones_disponibles)+5)/4).round.to_i.abs
		nutre = raciones_usadas * 2
	else
		raciones_usadas = ((raciones_disponibles - rand(raciones_disponibles)+5)/2).round.to_i.abs
		nutre = raciones_usadas
	end
	nutre = nutre.round
	session[:cocina][:comida] -= raciones_usadas.abs
	if session[:cocina][:comida] < 0 then session[:cocina][:comida] = 0 end
	puts "Raciones usadas: #{raciones_usadas}"

	elaborado = ["caldo", "pizza", "huevo frito", "emulsión de aroma de pato", "crema", "tostada", "ensalada", "macarrones", "ravioli", "pollo", "estofado", "filete", "huevo", "tarta", "hervido", "torta", "flan", "revuelto"]
	tecnica = ["de zanahoria", "con piña", "a la brasa", "con patatas", "con Nocilla", "con guindillas","con vello púbico", "con hielo seco", "al limón", "al orujo", "en su salsa", "con verduras", "con pollo", "de tomate", "con esencia de vainilla", "a la pimienta", "al roquefort", "al cilantro", "a la pimienta","al pil pil"]
	plato = "#{elaborado[rand(elaborado.length)]} #{tecnica[rand(tecnica.length)]}"
	puts "Plato preparado: #{plato}"

	salud = rand(nutre).to_i + 1

	if target == :self then
		resultado = "Cocinas #{plato}. Gastas #{raciones_usadas} raciones de comida. Recuperas #{salud} puntos de salud."
		session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],salud)

	else
		resultado = "#{session[:companeros][target][:nombre]} cocina #{plato}. Gasta #{raciones_usadas} raciones de comida. Recupera #{salud} puntos de salud."
		session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],salud)

	end

	return resultado 
end

def coger(target, inventory, item)
	inventory = inventory.delete(item)
	if target == :self then
		if item != 'pertenencias' then
			session[:atributos][:objetos] << item
			result = "Coges un #{item} de la cocina y lo guardas en tu habitación."
		else
			result = "Te quedas mirando el cajón pero no coges nada. Pierdes el tiempo."
		end
	else
		session[:companeros][target][:objetos] << item
		result = "#{session[:companeros][target][:nombre]} coge un #{item} de la cocina y lo guarda en su habitación."
	end
	return result
end

def wank(target)
	salud = rand(3)
	hambre = rand(1)
	paciencia = rand(10)
	tiempo = rand(120)+1
	if target == :self then
		resultado = "Te masturbas durante #{tiempo} minutos."
		if session[:atributos][:objetos].include? 'satisfyer' then
			bonus_satisfyer = rand(5)+1
			paciencia += bonus_satisfyer
			resultado += " Utilizas el Satisfyer (+#{bonus_satisfyer} por vicio)."
		end
		if salud > 0 then
			if hambre > 0 then
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],salud)
				resultado += " Respiras mejor. Ganas #{salud} puntos de salud."
			else
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
				resultado += " Sientes cansancio y hambre. Pierdes #{salud} puntos de salud."
			end
		end
		if paciencia > 0 then
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],salud)
			resultado += " Ganas #{paciencia} puntos de paciencia."
		end
		return resultado 
	else
		resultado = "#{session[:companeros][target][:nombre]} se masturba durante #{tiempo} minutos."
		if session[:companeros][target][:objetos].include? 'satisfyer' then
			bonus_satisfyer = rand(5)+1
			paciencia += bonus_satisfyer
			resultado += " Utiliza el Satisfyer (+#{bonus_satisfyer} por vicio)."
		end
		if salud > 0 then
			if hambre > 0 then
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],salud)
				resultado += " Gana #{salud} puntos de salud."
			else
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
				resultado += " Siente cansancio y hambre. Pierde #{salud} puntos de salud."
			end
		end
		if paciencia > 0 then
			session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			resultado += " Gana #{paciencia} puntos de paciencia."
		end	
		return resultado 	
	end
end

def flirt(from,to)
	puts to.inspect
	resultado = ''
	puts "ligando #{from} con #{to}, #{to.class}"
	tecnicas = ["el helicóptero", "el fontanero", "la amazona", "el butanero", "la liana", "la misa", "la pica", "el misionero", "el tanque", "el presbítero", "la monja", "el autónomo", "el político", "el diplomático", "la abadesa", "el Ignatius", "la serpiente", "el oso", "la marsopa", "la codorniz", "el escarabajo", "el pangolín", "el murciélago"]
	especificas = ["de Birmania", "a la griega", "sin arnés", "con arnés", "en Flandes", "a la brasa", "a la francesa", "de Camerún", "de Sodoma", "de Gomorra", "en el Ártico", "con dientes", "con uñas", "de cuero", "que paga impuestos", "en la sopa", "a la inversa", "sin red", "en el exilio"]
	juego = "#{tecnicas[rand(tecnicas.length)]} #{especificas[rand(especificas.length)]}"
	if from == :self then
		to = to.to_i
		resultado += "Intentas seducir a #{session[:companeros][to][:nombre]}."
		from_tirada = rand(session[:atributos][:inteligencia]) + rand(session[:atributos][:destreza])
		to_tirada = rand(session[:companeros][to][:inteligencia]) + rand(session[:companeros][to][:destreza])
		salud = rand(3)+1
		paciencia = rand(10)+1
		if session[:atributos][:objetos].include? 'poemario' then
			bonus_poemas = rand(25)+1
			from_tirada += bonus_poemas
			resultado += " Se te ocurre leerle unos poemas (+#{bonus_poemas} por brasa)."
		end
		if from_tirada >= to_tirada
			resultado += " ¡Lo consigues! Practicáis #{juego}. Ambos ganáis #{paciencia} puntos de paciencia."
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],paciencia)
		else
			resultado += " ¡Va a ser que no! Ambos perdéis #{paciencia} puntos de paciencia."
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia)
			session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia)
		end
		resultado += " El esfuerzo te ha costado #{salud} puntos de salud."
		session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
	else
		if to == :self then
			resultado += "#{session[:companeros][from][:nombre]} te intenta seducir."
			from_tirada = rand(session[:companeros][from][:inteligencia]) + rand(session[:companeros][from][:destreza])
			to_tirada = rand(session[:atributos][:inteligencia]) + rand(session[:atributos][:destreza])
			salud = rand(3)+1
			paciencia = rand(10)+1
			if session[:companeros][from][:objetos].include? 'poemario' then
				bonus_poemas = rand(25)+1
				from_tirada += bonus_poemas
				resultado += " Se le ocurre leerte unos poemas (+#{bonus_poemas} por brasa)."
			end
			if from_tirada >= to_tirada
				resultado += " ¡Lo consigue! Practicáis #{juego}. Ambos ganáis #{paciencia} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],paciencia)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			else
				resultado += " ¡Va a ser que no! Ambos perdéis #{paciencia} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],-1*paciencia)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia)
			end
			resultado += " El esfuerzo le ha costado #{salud} puntos de salud."
			session[:companeros][from][:fisico_actual] = heal(session[:companeros][from][:fisico_actual],session[:companeros][from][:fisico_max],-1*salud)
		else
			to = to[0].to_i
			resultado += "#{session[:companeros][from][:nombre]} intenta seducir a #{session[:companeros][to][:nombre]}."
			from_tirada = rand(session[:companeros][from][:inteligencia]) + rand(session[:companeros][from][:destreza])
			to_tirada = rand(session[:companeros][to][:inteligencia]) + rand(session[:companeros][to][:destreza])
			salud = rand(3)+1
			paciencia = rand(10)+1
			if session[:companeros][from][:objetos].include? 'poemario' then
				bonus_poemas = rand(25)+1
				from_tirada += bonus_poemas
				resultado += " Se le ocurre leerle unos poemas (+#{bonus_poemas} por brasa)."
			end
			if from_tirada >= to_tirada
				resultado += " ¡Lo consigue! Practican #{juego}. Ambos ganan #{paciencia} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],paciencia)
				session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],paciencia)
			else
				resultado += " ¡Va a ser que no! Ambos pierden #{paciencia} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],-1*paciencia)
				session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia)
			end
			resultado += " El esfuerzo le ha costado #{salud} puntos de salud."
			session[:companeros][from][:fisico_actual] = heal(session[:companeros][from][:fisico_actual],session[:companeros][from][:fisico_max],-1*salud)
		end
	end
	return resultado
end

def molest(from,to)
	resultado = ''
	tecnicas = ["el helicóptero", "el fontanero", "la amazona", "el butanero", "la liana", "la misa", "la pica", "el misionero", "el tanque", "el presbítero", "la monja", "el autónomo", "el político", "el diplomático", "la abadesa", "el Ignatius", "la serpiente", "el oso", "la marsopa", "la codorniz", "el escarabajo", "el pangolín", "el murciélago"]
	especificas = ["de Birmania", "a la griega", "sin arnés", "con arnés", "en Flandes", "a la brasa", "a la francesa", "de Camerún", "de Sodoma", "de Gomorra", "en el Ártico", "con dientes", "con uñas", "de cuero", "que paga impuestos", "en la sopa", "a la inversa", "sin red", "en el exilio"]
	juego = "#{tecnicas[rand(tecnicas.length)]} #{especificas[rand(especificas.length)]}"
	salud = rand(10)+1
	paciencia_tu = rand(20)+1
	paciencia_elle = rand(20)+1
	if from == :self then
		to = to.to_i
		resultado += "Intentas abusar sexualmente de #{session[:companeros][to][:nombre]}."
		from_tirada = rand(session[:atributos][:fuerza]) + rand(session[:atributos][:destreza])
		to_tirada = rand(session[:companeros][to][:fuerza]) + rand(session[:companeros][to][:destreza])

		if session[:atributos][:consumibles].include? 'burundanga' then
			bonus_burundanga = rand(25)+1
			from_tirada += bonus_burundanga
			resultado += " Se te ocurre usar burundanga (+#{bonus_burundanga} por enfermedad mental)."
			session[:atributos][:consumibles].slice!(session[:atributos][:consumibles].index('burundanga'))
		end
		if from_tirada >= to_tirada
			resultado += " ¡Lo consigues! Practicáis #{juego} a la fuerza. Ganas #{paciencia_tu} puntos de paciencia. #{session[:companeros][to][:nombre]} pierde #{paciencia_elle} puntos de paciencia."
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia_tu)
			session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia_elle)
		else
			resultado += " ¡Va a ser que no! Ambos perdéis #{paciencia_tu} puntos de paciencia."
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia_tu)
			session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia_tu)
		end
		resultado += " El esfuerzo te ha costado #{salud} puntos de salud."
		session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
	else
		if to == :self then
			resultado += "#{session[:companeros][from][:nombre]} intenta abusar de ti."
			from_tirada = rand(session[:companeros][from][:fuerza]) + rand(session[:companeros][from][:destreza])
			to_tirada = rand(session[:atributos][:fuerza]) + rand(session[:atributos][:destreza])
			if session[:companeros][from][:consumibles].include? 'burundanga' then
				bonus_burundanga = rand(25)+1
				from_tirada += bonus_burundanga
				session[:companeros][from][:consumibles].slice!(session[:companeros][from][:consumibles].index('burundanga'))
				resultado += " Se le ocurre usar burundanga (+#{bonus_burundanga} por enfermedad mental)."
			end
			if from_tirada >= to_tirada
				resultado += " ¡Lo consigue! Practicáis #{juego} a la fuerza. Gana #{paciencia_tu} puntos de paciencia. Tú pierdes #{paciencia_elle} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],paciencia_tu)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia_elle)
			else
				resultado += " ¡Va a ser que no! Ambos perdéis #{paciencia_tu} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],-1*paciencia_tu)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia_tu)
			end
			resultado += " El esfuerzo le ha costado #{salud} puntos de salud."
			session[:companeros][from][:fisico_actual] = heal(session[:companeros][from][:fisico_actual],session[:companeros][from][:fisico_max],-1*salud)
		else
			to = to[0].to_i
			resultado += "#{session[:companeros][from][:nombre]} intenta abusar sexualmente de #{session[:companeros][to][:nombre]}."
			from_tirada = rand(session[:companeros][from][:fuerza]) + rand(session[:companeros][from][:destreza])
			to_tirada = rand(session[:companeros][to][:fuerza]) + rand(session[:companeros][to][:destreza])
			if session[:companeros][from][:consumibles].include? 'burundanga' then
				bonus_burundanga = rand(25)+1
				from_tirada += bonus_burundanga
				session[:companeros][from][:consumibles].slice!(session[:companeros][from][:consumibles].index('burundanga'))
				resultado += " Se le ocurre usar burundanga (+#{bonus_burundanga} por enfermedad mental)."
			end
			if from_tirada >= to_tirada
				resultado += " ¡Lo consigue! Practican #{juego} a la fuerza. Gana #{paciencia_tu} puntos de paciencia. #{session[:companeros][to][:nombre]} pierde #{paciencia_elle} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],paciencia_tu)
				session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia_elle)
			else
				resultado += " ¡Va a ser que no! Ambos pierden #{paciencia_tu} puntos de paciencia."
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],-1*paciencia_tu)
				session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia_tu)
			end
			resultado += " El esfuerzo le ha costado #{salud} puntos de salud."
			session[:companeros][from][:fisico_actual] = heal(session[:companeros][from][:fisico_actual],session[:companeros][from][:fisico_max],-1*salud)
		end
	end
	return resultado
end

def attack(from,to)
	puts to.inspect
	resultado = ''
	puts "atacando #{from} con #{to}, #{to.class}"
	tecnicas = ["un puñetazo", "una patada", "un agarre", "una proyección", "una finta", "una técnica"]
	especificas = ["judo", "aikido", "boxeo", "kung fu", "taekwondo", "karate", "presa canaria", "moai thai", "wing chun", "kick boxing", "body combat", "jeet kune do", "capoeira"]
	juego = "#{tecnicas[rand(tecnicas.length)]} de #{especificas[rand(especificas.length)]}"
	danyo = ((rand(session[:atributos][:fuerza])+1)/2).abs
	paciencia_tu = rand(20)+1
	#paciencia_elle = rand(20)+1
	if from == :self then
		to = to.to_i
		resultado += "Atacas a #{session[:companeros][to][:nombre]} con #{juego}."
		from_tirada = rand(session[:atributos][:fuerza]) + rand(session[:atributos][:destreza])
		to_tirada = rand(session[:companeros][to][:fuerza]) + rand(session[:companeros][to][:destreza])
		arma = pick_weapon(session[:atributos][:objetos])
		if arma != false then
			bonus_arma = rand(25)+1
			from_tirada += bonus_arma
			resultado += " Guardas un as en la manga: #{arma} (+#{bonus_arma} por ingenio asesino)."
		end
		if from_tirada > to_tirada
			resultado += "  ¡Éxito! #{session[:companeros][to][:nombre]} pierde #{danyo} puntos de salud."
			session[:companeros][to][:fisico_actual] = heal(session[:companeros][to][:fisico_actual],session[:companeros][to][:fisico_max],-1*danyo)
		else
			juego = "#{tecnicas[rand(tecnicas.length)]} de #{especificas[rand(especificas.length)]}"
			danyo_recibido = ((rand(session[:companeros][to][:fisico_actual])+1)/2).abs
			resultado += " ¡Fallo! Contraataca con #{juego}. Pierdes #{danyo_recibido} puntos de salud. Ambos perdéis #{paciencia_tu} puntos de paciencia."
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*danyo_recibido)
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia_tu)
			session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia_tu)
		end		
	else
		if to == :self then
			resultado += "#{session[:companeros][from][:nombre]} te ataca con #{juego}."
			from_tirada = rand(session[:companeros][from][:fuerza]) + rand(session[:companeros][from][:destreza])
			to_tirada = rand(session[:atributos][:fuerza]) + rand(session[:atributos][:destreza])
			arma = pick_weapon(session[:companeros][from][:objetos])
			if arma != false then
				bonus_arma = rand(25)+1
				from_tirada += bonus_arma
				resultado += " Guarda un as en la manga: #{arma} (+#{bonus_arma} por ingenio asesino)."
			end
			if from_tirada >= to_tirada
				danyo = ((rand(session[:companeros][from][:fuerza])+1)/2).abs
				resultado += " ¡Éxito! Pierdes #{danyo} puntos de salud."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*danyo)
			else
				juego = "#{tecnicas[rand(tecnicas.length)]} de #{especificas[rand(especificas.length)]}"
				danyo_recibido = ((rand(session[:atributos][:fisico_actual])+1)/2).abs
				resultado += " ¡Va a ser que no! Contraatacas con #{juego}. #{session[:companeros][from][:nombre]} pierde #{danyo} puntos de salud. Ambos perdéis #{paciencia_tu} puntos de paciencia."
				session[:companeros][from][:fisico_actual] = heal(session[:companeros][from][:fisico_actual],session[:companeros][from][:fisico_max],-1*danyo_recibido)
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],-1*paciencia_tu)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia_tu)
			end
		else
			puts "to significa: #{to}, #{to.class}"
			to = to[0].to_i
			resultado += "#{session[:companeros][from][:nombre]} ataca a #{session[:companeros][to][:nombre]} con #{juego}."
			from_tirada = rand(session[:companeros][from][:fuerza]) + rand(session[:companeros][from][:destreza])
			to_tirada = rand(session[:companeros][to][:fuerza]) + rand(session[:companeros][to][:destreza])
			arma = pick_weapon(session[:companeros][from][:objetos])
			if arma != false then
				bonus_arma = rand(25)+1
				from_tirada += bonus_arma
				resultado += " Guarda un as en la manga: #{arma} (+#{bonus_arma} por ingenio asesino)."
			end
			if from_tirada >= to_tirada
				danyo = ((rand(session[:companeros][from][:fuerza])+1)/2).abs
				resultado += " ¡Éxito! #{session[:companeros][to][:nombre]} pierde #{danyo} puntos de salud."
				session[:companeros][to][:fisico_actual] = heal(session[:companeros][to][:fisico_actual],session[:companeros][to][:fisico_max],-1*danyo)
			else
				juego = "#{tecnicas[rand(tecnicas.length)]} de #{especificas[rand(especificas.length)]}"
				danyo_recibido = ((rand(session[:companeros][to][:fisico_actual])+1)/2).abs
				resultado += " ¡Va a ser que no! #{session[:companeros][to][:nombre]} contraataca con #{juego}. #{session[:companeros][from][:nombre]} pierde #{danyo} puntos de salud. Ambos pierden #{paciencia_tu} puntos de paciencia."
				session[:companeros][from][:fisico_actual] = heal(session[:companeros][from][:fisico_actual],session[:companeros][from][:fisico_max],-1*danyo_recibido)
				session[:companeros][from][:paciencia_actual] = heal(session[:companeros][from][:paciencia_actual],session[:companeros][from][:paciencia_max],-1*paciencia_tu)
				session[:companeros][to][:paciencia_actual] = heal(session[:companeros][to][:paciencia_actual],session[:companeros][to][:paciencia_max],-1*paciencia_tu)
			end
		end
	end
	return resultado
end

def steal(from, to, item)
	puts "Robando..."
	puts "From (#{from.class}): #{from.inspect}"
	puts "To (#{to.class}): #{to.inspect}"
	puts "Item (#{item.class}): #{item.inspect}"
	puts "robar a #{to.inspect}"
	resultado = ''
	consumibles = ['marihuana', 'cocaína', 'condón', 'setas mágicas', 'barrita energética', 'chicle', 'cigarro', 'vodka', 'mascarilla', 'burundanga', 'antimosquitos']
	if from == :self then
			puts "[self to other] intentado mangar a #{to.inspect}"
			alerta_roll = rand(session[:companeros][to][:destreza]) #aquó NO hace falta to[0]; cuando :self hace, to es directamente un INT
			puts "alerta roll: #{alerta_roll}"
			robo_roll = rand(session[:atributos][:destreza])
			puts "robo roll: #{robo_roll}"
	else
		if to == :self then
			puts "[other to self] intentado mangar a #{to.inspect}"
			alerta_roll = rand(session[:atributos][:destreza])
			puts "alerta roll: #{alerta_roll}"
		else
			puts "[other to other] intentado mangar a #{to.inspect}"
			puts "intentado mangar a #{to.inspect}"
			alerta_roll = rand(session[:companeros][to[0]][:destreza]) #aquó hace falta to[0], cuando other hace, to es un array de dos elementos [id, atributos]
			puts "alerta roll: #{alerta_roll}"
		end
		robo_roll = rand(session[:companeros][from][:destreza])
		puts "robo roll: #{robo_roll}"
	end

	if robo_roll > alerta_roll then
		if from == :self then
			resultado = "Intentas robar #{item} de la habitación de #{session[:companeros][to][:nombre]}..." #aquó no hace falta to[0]
			if item != 'pertenencias' then
				if consumibles.include? item then
					i = session[:companeros][to][:consumibles].index(item)
					session[:companeros][to][:consumibles].delete_at(i)
					session[:atributos][:consumibles] << item
				else
					i = session[:companeros][to][:objetos].index(item)
					session[:companeros][to][:objetos].delete_at(i)
					session[:atributos][:objetos] << item
				end
				resultado += " ¡Éxito! Robas #{item} de la habitación de #{session[:companeros][to][:nombre]}."
			else
				resultado += " Te quedas mirando el cuarto de #{session[:companeros][to][:nombre]} pero no robas nada. Pierdes el tiempo."
			end
		else
			if to == :self then
				resultado = "#{session[:companeros][from][:nombre]} intenta robar #{item} de tu habitación..."
				puts "Item para robar: #{item}"
				puts "consumibles: #{session[:atributos][:consumibles]}"
				puts "consumibles.include? item: #{consumibles.include? item.to_s}"
				if consumibles.include? item then
					# necesita asegurarse de que no ha elegido a un compañero con [:consumibles] = empty/nil
					i = session[:atributos][:consumibles].index(item)
					session[:atributos][:consumibles].delete_at(i)
					session[:companeros][from][:consumibles] << item
				else
					i = session[:atributos][:objetos].index(item)
					session[:atributos][:objetos].delete_at(i)
					session[:companeros][from][:objetos] << item
				end
				resultado += " ¡Éxito! Roba #{item} de tu habitación."
			else
				resultado = "#{session[:companeros][from][:nombre]} intenta robar algo de la habitación de #{session[:companeros][to[0]][:nombre]}..."
				if consumibles.include? item then
					puts "quitando consumible: #{item}"
					# necesita asegurarse de que no ha elegido a un compañero con [:consumibles] = empty/nil
					i = session[:companeros][to[0]][:consumibles].index(item)
					session[:companeros][to[0]][:consumibles].delete_at(i)
					session[:companeros][from][:consumibles] << item
					resultado += " ¡Éxito! Roba #{item}."
				elsif session[:companeros][to[0]][:objetos].include? item
					puts "quitando objeto: #{item}"
					i = session[:companeros][to[0]][:objetos].index(item)
					session[:companeros][to[0]][:objetos].delete_at(i)
					session[:companeros][from][:objetos] << item
					resultado += " ¡Éxito! Roba #{item}."
				else
					resultado += " ¡Falla!"
				end
				
			end
		end
	else
		if from == :self then
			if item != 'pertenencias' then
				resultado += " Intentas robar #{item} de la habitación de #{session[:companeros][to][:nombre]}... ¡Fallas! #{session[:companeros][to][:nombre]} descubre el intento y lo evita."
			else
				resultado += " Te quedas mirando el cuarto de #{session[:companeros][to][:nombre]} pero no robas nada. Pierdes el tiempo."
			end
		else
			if to == :self then
				resultado += " #{session[:companeros][from][:nombre]} intenta robarte #{item}... Le pillas. ¡Falla!"
			else
				resultado += " #{session[:companeros][from][:nombre]} intenta robar a #{session[:companeros][to[0]][:nombre]}... Le pillan. ¡Falla!"
			end
		end
	end

	return resultado
end 

def consume(target, inventory, item)
	puts "Consumiendo..."
	puts "Target (#{target.class}): #{target.inspect}"
	puts "Inventory (#{inventory.class}): #{inventory.inspect}"
	puts "Item (#{item.class}): #{item.inspect}"
	result = ''
	#inventory = inventory.delete(item)
	if target == :self then
		puts "Inventario pre consumo: #{session[:atributos][:consumibles]}"
		if item != 'pertenencias' then
			result = "Consumes #{item}."
			i = session[:atributos][:consumibles].index(item)
			session[:atributos][:consumibles].delete_at(i)
			case item
			when 'burundanga'
				salud = rand(10)+1
				paciencia = rand(10)+1
				result += " Nadie entiende por qué harías eso. Pierdes #{salud} puntos de salud y #{paciencia} puntos de paciencia."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia)
			when 'chicle'
				paciencia = rand(5) +1
				result += " Masticar goma comestible te da #{paciencia} puntos de paciencia."
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			when 'vodka'
				salud = rand(9)+1
				paciencia = rand(19)+1
				result += " Bebes para olvidar la situación. Pierdes #{salud} puntos de salud, pero ganas #{paciencia} puntos de paciencia."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			when 'barrita energética'
				salud = rand(5)+1
				result += " Todo ese muelsi mezclado con aditivos y prensado como un japonés en el metro te da #{salud} puntos de salud."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],salud)
			when 'marihuana'
				salud = -5 + rand(11); puts "salud --- #{salud}"
				paciencia = rand(9)+1
				result += " Como nadie tiene claro si la hierba es buena o mala, esta vez tu salud se ve afectada en #{salud} puntos de salud. Ganas #{paciencia} puntos de paciencia."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],salud)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			when 'cocaína'
				salud = rand(19)+1
				paciencia = rand(19)+1
				result += " Un tirito te da la vida. Modo Super Sayan. Ganas #{salud} puntos de salud, pero pierdes #{paciencia} puntos de paciencia."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],salud)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia)
			when 'condón'
				paciencia = rand(3)+1
				result += " Lo hinchas como un globo y juegas con él como si fueses imbécil. Ganas #{paciencia} puntos de paciencia."
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			when 'antimosquitos'
				salud = rand(5)+1
				paciencia = rand(5)+1
				result += " En un alarde de clarevidencia, rocías tus ojos para saber qué se siente. Pierdes #{salud} puntos de salud y #{paciencia} puntos de paciencia."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia)
			when 'cigarro'
				salud = rand(3)+1
				paciencia = rand(5)+1
				result += " Las volutas de humo te hacen meditar sobre tu propia existencia. Pierdes #{salud} puntos de salud, pero ganas #{paciencia} puntos de paciencia."
				session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			when 'setas mágicas'
				criatura = ["un dragón", "un elfo", "la alfombra", "un bolígrafo", "el árbol a través de la ventana", "la cama", "el armario", "las cacerolas", "la lámpara", "Matías Prats", "tu yo frente al espejo", "tu mano"]
				tema = ["la existencia", "la inexistencia", "la insoportable levedad del ser", "el espacio-tiempo", "las madalenas", "el virus", "la pandemia", "la reencarnación", "el Tao", "Budismo", "abrir los chrakras", "tu misión en la vida"]
				tiempo = 2 + rand(5)
				conversacion = " Hablas con #{criatura[rand(criatura.length)]} sobre #{tema[rand(tema.length)]} durante #{tiempo} horas... "
				paciencia = -10 + rand(21)
				result += conversacion
				if paciencia > 0
					result += " Es un buen viaje. Ganas #{paciencia} puntos de paciencia."
				elsif paciencia == 0
					result += " Es un viaje absurdo que no te lleva a ningún lugar. Te quedas igual."
				elsif paciencia < 0
					result += " Es un mal viaje. Pierdes #{paciencia} puntos de paciencia."
				end
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			when 'mascarilla'
				paciencia = rand(5)+1
				result += " Te la pruebas, te la pones de sombrero, la usas para vendar tus ojos, haces papiroflexia, la rompes en trocitos, haces confeti, tiras los restos al wáter. Ganas #{paciencia} puntos de paciencia."
				session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			end	
		else
			result += "Te quedas mirando tu cuarto pero no consumes nada. Pierdes el tiempo."
		end
		puts "Inventario post consumo: #{session[:atributos][:consumibles]}"
	else
			result = "#{session[:companeros][target][:nombre]} consume #{item}."
			puts "Actor: #{result}"
			i = session[:companeros][target][:consumibles].index(item)
			puts "i to delete: #{i}"
			puts "consumibles: #{session[:companeros][target][:consumibles]}"
			session[:companeros][target][:consumibles].delete_at(i)
			case item
			when 'burundanga'
				salud = rand(10)+1
				paciencia = rand(10)+1
				result += " Nadie entiende por qué haría eso. Pierde #{salud} puntos de salud y #{paciencia} puntos de paciencia."
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],-1*paciencia)
			when 'chicle'
				paciencia = rand(5) +1
				result += " Masticar goma comestible le da #{paciencia} puntos de paciencia."
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			when 'vodka'
				salud = rand(9)+1
				paciencia = rand(19)+1
				result += " Bebe para olvidar la situación. Pierde #{salud} puntos de salud, pero gana #{paciencia} puntos de paciencia."
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			when 'barrita energética'
				salud = rand(5)+1
				result += " Todo ese muelsi mezclado con aditivos y prensado como un japonés en el metro le da #{salud} puntos de salud."
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],salud)
			when 'marihuana'
				salud = -5 + rand(11)
				paciencia = rand(9)+1
				result += " Como nadie tiene claro si la hierba es buena o mala, esta vez su salud se ve afectada en #{salud} puntos de salud. Gana #{paciencia} puntos de paciencia."
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],salud)
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			when 'cocaína'
				salud = rand(19)+1
				paciencia = rand(19)+1
				result += " Un tirito le da la vida. Modo Super Sayan. Gana #{salud} puntos de salud, pero pierde #{paciencia} puntos de paciencia."
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],salud)
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],-1*paciencia)
			when 'condón'
				paciencia = rand(3)+1
				result += " Lo hincha como un globo y juega con él como si fuese imbécil. Gana #{paciencia} puntos de paciencia."
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			when 'antimosquitos'
				salud = rand(5)+1
				paciencia = rand(5)+1
				result += " En un alarde de clarevidencia, rocía sus ojos para saber qué se siente. Pierde #{salud} puntos de salud y #{paciencia} puntos de paciencia."
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],-1*paciencia)
			when 'cigarro'
				salud = rand(3)+1
				paciencia = rand(5)+1
				result += " Las volutas de humo le hacen meditar sobre su propia existencia. Pierde #{salud} puntos de salud, pero gana #{paciencia} puntos de paciencia."
				session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			when 'setas mágicas'
				criatura = ["un dragón", "un elfo", "la alfombra", "un bolígrafo", "el árbol a través de la ventana", "la cama", "el armario", "las cacerolas", "la lámpara", "Matías Prats", "tu yo frente al espejo", "tu mano"]
				tema = ["la existencia", "la inexistencia", "la insoportable levedad del ser", "el espacio-tiempo", "las madalenas", "el virus", "la pandemia", "la reencarnación", "el Tao", "Budismo", "abrir los chrakras", "tu misión en la vida"]
				tiempo = 2 + rand(5)
				conversacion = " Habla con #{criatura[rand(criatura.length)]} sobre #{tema[rand(tema.length)]} durante #{tiempo} horas... "
				paciencia = -10 + rand(21)
				result += conversacion
				if paciencia > 0
					result += " Es un buen viaje. Gana #{paciencia} puntos de paciencia."
				elsif paciencia == 0
					result += " Es un viaje absurdo que no le lleva a ningún lugar. Se queda igual."
				elsif paciencia < 0
					result += " Es un mal viaje. Pierde #{paciencia.abs} puntos de paciencia."
				end
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			when 'mascarilla'
				paciencia = rand(5)+1
				result += " Se la prueba, se la pone de sombrero, la usa para vendar sus ojos, hace papiroflexia, la rompe en trocitos, hace confeti, tira los restos al wáter. Gana #{paciencia} puntos de paciencia."
				session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],paciencia)
			end	
	end
	return result
end

def plunder(from, to)
	puts "Saqueando..."
	puts "To (#{to.class}): #{to.inspect}"
	if from == :self then
		to = to.to_i
	else
		to = to[0].to_i
	end
	resultado = ''

	reprimendas = ["Tus padres estarían orgullosos de ti.", "No opone resistencia.", "Luego te miras al espejo y lloras, pero no lo devuelves.", "Te sientes como una rata.", "Respiras hondo y se te pasa el disgusto.", "Justo lo que habría querido."]

	if from == :self then
		resultado += "Aprovechando que #{session[:companeros][to][:nombre]} ha muerto, robas todas sus pertenencias y #{session[:companeros][to][:dinero]}€. #{reprimendas[rand(reprimendas.length)]}"
		session[:atributos][:objetos] += session[:companeros][to][:objetos]
		session[:companeros][to][:objetos] = []
		session[:atributos][:consumibles] += session[:companeros][to][:consumibles]
		session[:companeros][to][:consumibles] = []
		session[:atributos][:dinero] += session[:companeros][to][:dinero]
		session[:companeros][to][:dinero] = 0
		session[:companeros][to][:estados] << 'saqueado'
	else
		resultado += "Aprovechando que #{session[:companeros][to][:nombre]} ha muerto, #{session[:companeros][from][:nombre]} roba todas sus pertenencias y #{session[:companeros][to][:dinero]}€."
		session[:companeros][from][:objetos] += session[:companeros][to][:objetos]
		session[:companeros][to][:objetos] = []
		session[:companeros][from][:consumibles] += session[:companeros][to][:consumibles]
		session[:companeros][to][:consumibles] = []
		session[:companeros][from][:dinero] += session[:companeros][to][:dinero]
		session[:companeros][to][:dinero] = 0
		session[:companeros][to][:estados] << 'saqueado'
	end

	return resultado
end

def recycle(from, to)
	if from == :self then
		to = to.to_i
	else
		to = to[0].to_i
	end
	
	resultado = ''
	puts "Reciclando..."
	puts "To (#{to.class}): #{to.inspect}"
	puts "From (#{from.class}): #{from.inspect}"

	formas = ["Sus huesos servirán para caldo.", "Los músculos dan para buenos filetes.", "La casquería servirá para platos exóticos.", "No es diferente a descuartizar un cerdo.", "No hay nada como su piel para unos buenos callos.", "El hedor se pasa cuando abrís la ventana.", "Freír la sangre la preservará más tiempo."]

	raciones = session[:companeros][to][:fisico_max]/2 + rand(session[:companeros][to][:fisico_max])
	session[:cocina][:comida] += raciones
	session[:companeros][to][:estados] << 'reciclado'
	puts "estado del reciclado: #{session[:companeros][to][:estados]}"
	paciencia = rand(20)+1

	if from == :self then
		session[:atributos][:paciencia_actual] -= paciencia
		resultado += "Aprovechando que #{session[:companeros][to][:nombre]} ha muerto, se te ocurre reciclar su cadáver. #{formas[rand(formas.length)]} Ganáis #{raciones} raciones de comida. Pierdes #{paciencia} puntos de paciencia."
	else
		from = from.to_i
		session[:companeros][from][:paciencia_actual] -= paciencia
		resultado += "Aprovechando que #{session[:companeros][to][:nombre]} ha muerto, a #{session[:companeros][from][:nombre]} se le ocurre reciclar su cadáver. #{formas[rand(formas.length)]} Ganáis #{raciones} raciones de comida. Pierde #{paciencia} puntos de paciencia."
	end
	
	return resultado
end

def walkdog
	resultado = ''
	if session[:perro] == nil
		roll_cotillas = (rand(session[:parque][:cotillas])*4)+10
		roll_jugador = rand(session[:atributos][:destreza])+rand(session[:atributos][:inteligencia])
		if roll_jugador > roll_cotillas then
			paciencia = rand(26)+5
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
			resultado += "Te escapas de casa y das un paseo con la única intención de aliviar tu claustrofobia. Nadie te descubre. Ganas #{paciencia} puntos de paciencia."
		else
			resultado += "Te escapas de casa y das un paseo con la única intención de aliviar tu claustrofobia. Un Policía de Balcón™ llama a la Policía de Verdad™."
			multa = 30+rand(51)
			if poder_pagar(session[:atributos],multa) then
				resultado += " Te multan con #{multa}€."
				session[:atributos][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Te multan con #{multa}€. Como no puedes pagar, te quedas sin dinero y recibes una paliza que te resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:atributos][:fisico_actual] -= golpe
				session[:atributos][:dinero] = 0
			end
		end
	else
		resultado += "Bajas a dar un paseo con #{session[:perro][:nombre]} para que haga cosas de perros mientras tú respiras aire fresco."
		paciencia = rand(26)+5
		case session[:perro][:tamano]
			when 1
				t_p = 25
			when 2
				t_p = 50
			when 3
				t_p = 75
			when 4 
				t_p = 100
		end
		# los pechos deciden sin _pelear y luego _luchan
		roll_perro_pelea = rand(t_p)
		roll_perros_pelea = rand(session[:parque][:perros])
		if roll_perro_pelea >= roll_perros_pelea then
			resultado += " El temor que inspira tu mejor amigo hace que no haya problemas."
		else
			resultado += "Tú perro y los demás comienzan a ladrarse, "
			roll_perro_lucha = rand(t_p)
			roll_perros_lucha = rand(session[:parque][:perros])
			if roll_perro_lucha > roll_perros_lucha then
				resultado += "pero tu mejor amigo consigue amedrentarlos tras matar a #{roll_perro_lucha-roll_perros_lucha} mejores amigos y amigas de los hombres y las mujeres."
			else
				forma_morir = ['Lo mutilan delante de tus ojos sin que puedas hacer nada', 'Ya han comenzado a comerse sus tripas cuando conseguís separarlos del cadáver', 'De su yugular brota un chorro de sangre que anuncia el final', 'Todavía grita cuando sus vísceras tocan el suelo', 'Te vienen a la mente imágenes de cuando era un cachorro', 'Alguien hace una foto con flash desde un balcón']
				resultado += "y la cosa va a peor. #{roll_perros_lucha-roll_perro_lucha} muerden a #{session[:perro][:nombre]} hasta acabar con su vida. #{forma_morir[rand(forma_morir.length)]}. Pierdes a tu mascota para siempre."
				session[:perro] = nil
			end
		end
		session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],paciencia)
		resultado += " Después de todo, ver el cielo sobre tu cabeza te ha hecho recuperar #{paciencia} puntos de paciencia."
	end
	return resultado
end

def buy_drogaina(agent)
	resultado = ''
	bolsa_de_la_compra = []
	dealers = [' un yonki', ' una anciana', ' un repartidor de Amazon', ' un rider de Deliveroo', ' una monja', ' un runner', ' un profe de primaria', ' tu profe de secundaria', ' un profe de la universidad', ' un cura', ' una ex pareja', ' un paseador (o paseadora) de perros (o perras)', ' Elon Musk disfrazado de sintecho', ' a un policía', ' a un guardia civil']
	drojas = ['marihuana', 'cocaína', 'setas mágicas', 'cigarro', 'vodka', 'burundanga']
	if agent == :self then
		resultado += 'Bajas al parque en busca de drogaína de la mejor calidad.'

		# Compras droja?
		## Bonus por perro
		if session[:perro] != nil then
			bonus_perro = 1+rand(31)
			resultado += " Llevas a tu mejor amigo #{session[:perro][:nombre]} para disimular (+#{bonus_perro} por picardía)."
		else
			bonus_perro = 0
		end
		## Encuentras al dealer?
		
		if (rand(100) <= session[:parque][:camellos]+(session[:atributos][:inteligencia]/10)) && (session[:atributos][:dinero] >= 1) then
			droja_encontrada = drojas[rand(drojas.length)]
			gramos = 2+rand(4)
			gramos.times do
				bolsa_de_la_compra << droja_encontrada
			end
			coste_total = rand(session[:atributos][:dinero])+1
			coste = coste_total-(coste_total/(rand(3)+1)).abs
			session[:atributos][:dinero] -= coste
			resultado += " Encuentras a#{dealers[rand(dealers.length)]} que te vende #{gramos} dosis de #{droja_encontrada} por #{coste}€."
		else
			resultado += " No encuentras a nadie que te venda, aunque #{dealers[rand(dealers.length)]} te miró de reojo antes de desaparecer."
		end

		## Te denuncian?
		roll_cotillas = rand(session[:parque][:cotillas]*2)+10
		roll_jugador = rand(session[:atributos][:destreza])+rand(session[:atributos][:inteligencia]) + bonus_perro
		if roll_jugador > roll_cotillas then
			resultado += ""
		else
			resultado += " Entre tanto, Un Policía de Balcón™ llama a la Policía de Verdad™."
			multa = 30+rand(51)
			if bolsa_de_la_compra != [] then
				resultado += " La policía te quita lo que habías comprado."
				multa *= 2
				bolsa_de_la_compra = []
			end
			if poder_pagar(session[:atributos],multa) then
				resultado += " Te multan con #{multa}€."
				session[:atributos][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Te multan con #{multa}€. Como no puedes pagar, te quedas sin dinero y recibes una paliza que te resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:atributos][:fisico_actual] -= golpe
				session[:atributos][:dinero] = 0
			end
		end
		## Llegas a casa
		puts bolsa_de_la_compra
		if bolsa_de_la_compra != [] then
			puts "Guardando bolsa de la compra"
			session[:atributos][:consumibles] = session[:atributos][:consumibles] + bolsa_de_la_compra
		end
	else
		resultado += "#{session[:companeros][agent][:nombre]} baja al parque en busca de drogaína de la mejor calidad."

		# Compras droja?
		## Encuentras al dealer?
		if (rand(100) <= session[:parque][:camellos]+(session[:companeros][agent][:inteligencia]/10)) && (session[:companeros][agent][:dinero] >= 1) then
			droja_encontrada = drojas[rand(drojas.length)]
			gramos = 2+rand(4)
			gramos.times do
				bolsa_de_la_compra << droja_encontrada
			end
			coste_total = rand(session[:companeros][agent][:dinero])+1
			coste = coste_total-(coste_total/(rand(3)+1)).abs
			session[:companeros][agent][:dinero] -= coste
			resultado += " Encuentra a#{dealers[rand(dealers.length)]} que le vende #{gramos} dosis de #{droja_encontrada} por #{coste}€."
		else
			resultado += " No encuentra a nadie que le venda, aunque #{dealers[rand(dealers.length)]} le miró de reojo antes de desaparecer."
		end

		## Le denuncian?
		roll_cotillas = rand(session[:parque][:cotillas]*2)+10
		roll_jugador = rand(session[:companeros][agent][:destreza])+rand(session[:companeros][agent][:inteligencia])
		if roll_jugador > roll_cotillas then
			resultado += ""
		else
			resultado += " Entre tanto, Un Policía de Balcón™ llama a la Policía de Verdad™."
			multa = 30+rand(51)
			if bolsa_de_la_compra != [] then
				resultado += " La policía le quita lo que había comprado."
				multa *= 2
				bolsa_de_la_compra = []
			end
			if poder_pagar(session[:companeros][agent],multa) then
				resultado += " Le multan con #{multa}€."
				session[:companeros][agent][:dinero] -= multa
			else
				golpe = rand(25)
				resultado += " Le multan con #{multa}€. Como no puede pagar, se queda sin dinero y recibe una paliza que le resta #{golpe} puntos de salud. Disfruten lo votado."
				session[:companeros][agent][:fisico_actual] -= golpe
				session[:companeros][agent][:dinero] = 0
			end
		end
		## Llega a casa
		if bolsa_de_la_compra != [] then
			session[:companeros][agent][:consumibles] = session[:companeros][agent][:consumibles] + bolsa_de_la_compra
		end
	end
	return resultado
end

def teletrabajar(target)
	resultado = ''
	horas = 2+rand(13)
	salud = 1+rand(9)
	trabajos = ["redactar titulares click-bait", "responder a clientes quejicas", "participar en un estudio sobre masturbación compulsiva", "escribir discursos de políticos", "programar páginas porno", "editar fotos de gatos", "grabar vídeos para YouTurd", "curar contenidos", "hacer monólogos por streaming", "espectáculos eróticos por webcam", "ayudar a blanquear dinero", "dar clases de inglés", "extorsionar a morosos", "moderar foros", "debuggear juegos de web", "estafar con phising", "defraudar a Gurgel con redes de blogs falsas con tráfico falso que hace falsos clicks en AdWordz", "crackear juegos", "piratear películas", "vender cuentas premium robadas"]
	if target == :self then
		dinero = 2+ rand(session[:atributos][:inteligencia])
		resultado += "Buscas trabajo on-line: #{trabajos[rand(trabajos.length)]}."
		if session[:atributos][:objetos].include? 'ordenador' then
			bonus_sueldo = 2+rand(19)
			resultado += " Utilizas el ordenador (+#{bonus_sueldo} por hacker)."
		else
			bonus_sueldo = 0
		end
		session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
		resultado += " Tienes hambre y pierdes #{salud} puntos de salud."
		session[:atributos][:dinero] += dinero+bonus_sueldo
		resultado += " Trabajas #{horas} horas y ganas #{dinero+bonus_sueldo}€."
		return resultado 
	else
		dinero = 2+ rand(session[:companeros][target][:inteligencia])
		resultado += "#{session[:companeros][target][:nombre]} busca trabajo on-line: #{trabajos[rand(trabajos.length)]}."
		if session[:companeros][target][:objetos].include? 'ordenador' then
			bonus_sueldo = 2+rand(19)
			resultado += " Utiliza el ordenador (+#{bonus_sueldo} por hacker)."
		else
			bonus_sueldo = 0
		end
		session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
		resultado += " Tiene hambre y pierde #{salud} puntos de salud."
		session[:companeros][target][:dinero] += dinero+bonus_sueldo
		resultado += " Trabaja #{horas} horas y gana #{dinero+bonus_sueldo}€."
		return resultado
	end
end

def buy_food(target, raciones)
	resultado = ''
	if target == :self then
		problemas = ["Una señora te estornuda en la cara", "Tropiezas con un runner que carraspea", "Un coche no frena a tiempo y te arrolla", "Chocas con una farola mientras mirabas un culo", "Giras de prisa y las bolsas de la compra te retuercen los dedos"]
		if raciones == 'raciones' then
			resultado += "Bajas al supermercado pero no compras nada. Enhorabuena por perder el tiempo."
			return resultado
		else
			coste = (raciones.to_i)*session[:precio_comida]
			session[:atributos][:dinero] -= coste
			resultado += "Compras #{raciones} raciones de comida. Te cuesta #{coste}€."
		end
		# problemas?
		encontrar_problemas = rand(100)
		evitar_problemas = rand(session[:atributos][:inteligencia])
		if encontrar_problemas > evitar_problemas then
			salud = 1+rand(9)
			paciencia = 1+rand(9)
			session[:atributos][:fisico_actual] = heal(session[:atributos][:fisico_actual],session[:atributos][:fisico_max],-1*salud)
			session[:atributos][:paciencia_actual] = heal(session[:atributos][:paciencia_actual],session[:atributos][:paciencia_max],-1*paciencia)
			resultado += " #{problemas[rand(problemas.length)]}. Pierdes #{salud} puntos de salud y #{paciencia} puntos de paciencia."
		end
		session[:cocina][:comida] += raciones.to_i
	else
		problemas = ["Una señora le estornuda en la cara", "Tropieza con un runner que carraspea", "Un coche no frena a tiempo y le arrolla", "Choca con una farola mientras miraba un culo", "Gira de prisa y las bolsas de la compra le retuercen los dedos"]
		coste = (raciones.to_i)*session[:precio_comida]
		session[:companeros][target][:dinero] -= coste
		resultado += "#{session[:companeros][target][:nombre]} compra #{raciones} raciones de comida. Le cuesta #{coste}€."
		# problemas?
		encontrar_problemas = rand(100)
		evitar_problemas = rand(session[:companeros][target][:inteligencia])
		if encontrar_problemas > evitar_problemas then
			salud = 1+rand(9)
			paciencia = 1+rand(9)
			session[:companeros][target][:fisico_actual] = heal(session[:companeros][target][:fisico_actual],session[:companeros][target][:fisico_max],-1*salud)
			session[:companeros][target][:paciencia_actual] = heal(session[:companeros][target][:paciencia_actual],session[:companeros][target][:paciencia_max],-1*paciencia)
			resultado += " #{problemas[rand(problemas.length)]}. Pierdes #{salud} puntos de salud y #{paciencia} puntos de paciencia."
		end
		session[:cocina][:comida] += raciones.to_i
	end
	return resultado
end


# EXTRAS -----------------------------------------------------------------------------------------------

def inventa_noticia
	periodistas = ["Antonio Ferreras", "Newtral", "Maldita.es", "Ana Pastor", "Ignacio Escolar", "Eduardo Inda", "Jiménez Losantos", "Antonio Maestre", "Miguel Lacambra", "Pedro J. Ramírez", "Pedro Piqueras", "Jordi Évole", "Ana Rosa Quintana", "Carlos Herrera", "Iñaki Gabilondo", "Susana Griso", "Íker Jiménez", "Carmen Porter", "Luis del Pino", "Un Tío Blanco Hetero", "Barbijaputa", "Gerardo Tecé"]
	famosos = ["David Broncano", "Un Tío Blanco Hetero", "Cristina Pedroche", "Ana Obregón", "María Teresa Campos", "Messi", "Tezanos", "Cristiano Ronaldo", "Buenafuente", "Alberto Chicote", "Rosalía", "Julio Iglesias", "Rafa Nadal", "Mario Casas", "Jorge Javier Vázquez", "Karlos Arguiñano", "Jesús Calleja", "Chenoa", "David Bisbal", "Juan Ramón Rallo"]
	politicos = ["Pablo Iglesias", "Pedro Sánchez", "Íñigo Errejón","Álex Pastor", "Grande-Marlaska", "Donald Trump", "Irene Montero", "Santiago Abascal", "Pedro Duque", "Fernando Simón", "Adriana Lastra", "Inés Arrimadas", "Pablo Casado", "Carmen Calvo", "Nadia Calviño", "Teresa Ribera", "María Aránzazu González", "María Jesús Montero", "Yolanda Díaz", "Isabel Celaá", "Alberto Garzón", "Salvador Illa", "Manuel Castells", "José Luis Escrivá"]
	gente = periodistas + famosos + politicos
	culpables = ["Europa", "EE.UU.", "Wuhan", "China", "los 100tífikos", "la OTAN", "la OMS", "el BCE", "Alemania", "ForoCoches", "MediaVida","la oposición", "el terrorismo islámico", "Íker Jiménez", "los bulos", "los alienígenas", "los nazis en la cara oculta de la Luna", "el 5G", "los recortes", "el inventor del abrefácil", "JavaScript", "Facebook", "los niños", "las feic nius", "el CSIC", "el CNI", "La Moncloa"]
	pecado = ["esparcir el virus", "viajar a Italia", "hacer un mitin político","indagar en los errores del Gobierno", "llorar en público", "ser el heterónimo de #{gente[rand(gente.length)]}", "aplaudir demasiado alto", "fabricar material sanitario con bolsas de basura","no respetar la distancia de seguridad", "defraudar al fisco", "acostarse con #{gente[rand(gente.length)]}", "difundir bulos", "reciclar mal", "haber contagiado a #{gente[rand(gente.length)]}", "no poder pagar la hipoteca", "controlar los bulos", "utilizar armas nucleares para desinfectar", "defender al ejército", "rechazar la ayuda de la UME", "recortar en sanidad", "perseguir la disidencia", "comprar mascarillas defectuosas", "utilizar tests defectuosos", "dejar salir a los niños", "hacer una serie de TV quitándole hierro al asunto", "expulsar a los médicos de las comunidades de vecinos", "salir con espadas a la calle", "ser nazi", "alentar el terrorismo", "#EsteVirusLoParamosUnidos"]
	titulares = ["#{periodistas[rand(periodistas.length)]} acusa a #{gente[rand(gente.length)]} de #{pecado[rand(pecado.length)]}.",
				"#{periodistas[rand(periodistas.length)]} dice que #{pecado[rand(pecado.length)]} no es delito.",
				"#{periodistas[rand(periodistas.length)]} dice que #{pecado[rand(pecado.length)]} es delito.",
				"#{periodistas[rand(periodistas.length)]} dice que unos niños han jugado con chocolate en un pueblo peridodo de la mano de Dios.",
				"El Papa reza por las víctimas.",
				"#{gente[rand(gente.length)]} ha pillado el bicho.",
				"#{gente[rand(gente.length)]} dice que la culpa es de #{culpables[rand(culpables.length)]}.",
				"Lanzan una bomba atómica sobre #{culpables[rand(culpables.length)]}.",
				"#{gente[rand(gente.length)]} dice que #{pecado[rand(pecado.length)]}  no significa #{pecado[rand(pecado.length)]}.",
				"#{gente[rand(gente.length)]} declara que nadie tendría que creerse las mentiras de #{periodistas[rand(periodistas.length)]}.",
				"El Gobierno le echa la culpa de su gestión a #{culpables[rand(culpables.length)]}.",
				"#{politicos[rand(politicos.length)]} asegura que estamos llegando al pico de la curva.",
				"#{politicos[rand(politicos.length)]} pide perdón por las mascarillas defectuosas.",
				"#{politicos[rand(politicos.length)]} llora en una rueda de prensa.",
				"#{politicos[rand(politicos.length)]} sugiere que #{pecado[rand(pecado.length)]} pueda ser un bulo.",
				"#{politicos[rand(politicos.length)]} se ríe en una rueda de prensa.",
				"#{gente[rand(gente.length)]} sugiere destituir a #{politicos[rand(politicos.length)]}.",
				"Puigdemont come palomitas desde Bélgica.",
				"#{rand(50)+2} perros atacan a un niño en un parque.",
				"#{rand(50)+2} niños atacan a un perro en un parque.",
				"Un cotilla ha saltado por la ventana.",
				"Han descubierto a #{gente[rand(gente.length)]} chupando los botones del ascensor.",
				"#{gente[rand(gente.length)]} se querella contra #{gente[rand(gente.length)]} por #{pecado[rand(pecado.length)]}",
				"Un helicóptero policial se estrella sobre #{culpables[rand(culpables.length)]}.",
				"Se filtran correos de #{culpables[rand(culpables.length)]} echándole la culpa de la pandemia a #{pecado[rand(pecado.length)]}."]
	return titulares[rand(titulares.length)]
end





#def cat_pet(target)
#	result = ''
#	cat_roll = rand(100)
#	if target == :self then
#		session[:atributos][:destreza]
#	else
#		session[:companeros][target][:destreza]
#	end
#	return result
#end


run!
end